//////// GLOBAL VARS ////////
var timer_id;
var dax = 9800;
var greentick = Math.round(8 + 5*Math.random());
var nbtick = 0;
var signal = 0;


//////// FUNCTIONS ////////

////////
function tickthedax() {

	clearTimeout(timer_id);
	var timetonexttick = 200+800*Math.random(); //0.2 < x < 1.0s
	timer_id = setTimeout(tickthedax, timetonexttick);

	// smooth uptrend/normal volatility
	max = +1.2;
	min = -0.9;
	delta = Math.random() * (max - min) + min;

	dax = dax + delta;
	dax = Math.round(dax*10)/10;
	$('#dax').html(dax.toFixed(1));

	nbtick++;

	if (nbtick == greentick) {
		nbtick=0;
		$('#dax').css("background-color","yellow");
		greentick = Math.round(5 + 5*Math.random()); // 5 < x < 10
		signal = Date.now();
	}
	else
	{
		$('#dax').css("background-color","white");
	}

}

////////
function calc_average(array_name) {

	var tot=0;
	var nb=0;
	$(array_name+" li").each(function (i,e) {
		tot = tot + $(e).html()*1.0;
		nb++;
	})

	if (nb>0) {
		$(array_name+"-header li.cnt").html("Count: "+nb);
		$(array_name+"-header li.avg").html("Average: "+ Math.round(tot/nb) +" ms");
	}
	else
	{
		$(array_name+'-header li.cnt').empty().html('Count :');
		$(array_name+'-header li.avg').empty().html('Average :');
		$(array_name+'-header li.cnt').empty().html('Count :');
		$(array_name+'-header li.avg').empty().html('Average :');
	}

}


//////// BINDS ////////

////////
$(document).keydown(function(e) {

	if (signal>0)
	{
	    switch(e.which) {

	        case 38: // arrow up
				$('#tme-key ul').prepend($('<li>')
						.addClass("list-group-item text-right")
						.html(Date.now()-signal)
				);
				calc_average("#tme-key");
				signal=0;

	        break;

	        default: return; // exit this handler for other keys
	    }
	    e.preventDefault(); // prevent the default action
	}
});

////////
$("#reakt").click(function () {

	if (signal>0)
	{
		$('#tme-mouse ul').prepend($('<li>')
					.addClass("list-group-item text-right")
					.html(Date.now()-signal)
		);
		calc_average("#tme-mouse");
		signal=0;
	}

});

////////
$("#start").click(function () {
	$("#reakt").removeClass('disabled');
	timer_id = setTimeout(tickthedax, 100);

});

////////
$("#stop").click(function () {
	$("#reakt").addClass('disabled');
	$('#dax').html("-").css("background-color","white");
	clearTimeout(timer_id);
});

////////
$("#reset").click(function () {
	$('#tme-mouse ul').empty();
	$('#tme-key ul').empty();

	$('#tme-key-header li.cnt').empty().html('Count :');
	$('#tme-key-header li.avg').empty().html('Average :');
	$('#tme-mouse-header li.cnt').empty().html('Count :');
	$('#tme-mouse-header li.avg').empty().html('Average :');
});

////////
$("#tme-mouse").on("click","li",function () {
	$(this).remove();
	calc_average("#tme-mouse");
});

////////
$("#tme-key").on("click","li",function () {
	$(this).remove();
	calc_average("#tme-key");
});




